/** \file com_io.c
 * \brief  -  USART
 * \par
 *  "  "   printf()  ..
 *    ,   #BAUD,   USART1 (  2)
 * \par
 * \author ARV
 * \note
 * \n :
 * \n \date	05.02.2009 ... 	__.__.2008
 * \par
 * \version 1.0 beta	\n
 * Copyright 2008  ARV. All rights reserved. </b>
 * \par
 *   :\n
 * 	-# WinAVR-20080411    
 *
 */
#include <avr/io.h>
#include <avr/wdt.h>
#include <util/delay.h>
#include "avr_helper.h"
#include "com_io.h"
#if defined(_DEBUG_)

/**         ( )
 *
 * @param c  
 */
void putch(char c){
	while(bit_is_clear(UCSRA, UDRE));
	UDR = c;
}


/**   .
 *
 */
///    USART   -.
INIT(7){	///        .
	   UCSRA = 0;
	#include <util/setbaud.h>
	   UBRRH = UBRRH_VALUE;
	   UBRRL = UBRRL_VALUE;
	#if USE_2X
	   UCSRA |= (1 << U2X);
	#else
	   UCSRA &= ~(1 << U2X);
	#endif
	   UCSRB |= _BV(TXEN);
	#if ONLY_OUT == 0
	   UCSRB |= _BV(RXEN);
	#endif
	   UCSRC = 0x86;


   DDRD |= _BV(PD1);
   //stdout = &mystdout;
   //stdin = stdout;
}

 
#endif

