/** \file main.c
 * \brief   
 * \par
 *       
 *
 * \author ARV
 * \date	4 . 2017 .
 * \version 0.1	\par
 * \copyright Copyright 2015  ARV. All rights reserved.
 * \mainpage  
 * \par 
 *  " "    
 * WS2812     .
 * \par 
 *   :
 * -  <a href="http://elm-chan.org/works/akilcd/report_e.html">FFT by Chan</a>
 * -  <a href="http://elm-chan.org/fsw/ff/00index_p.html">Petit Fat FS by Chan</a>
 * -  <a href="http://damian.pecke.tt/">DAMIAN PECKETT</a>
 * -    WS2812   SPI  <a href="http://forum.cxem.net/index.php?/profile/187660-mishany/">Mishany</a>
 * \par :
 * -# avr-gcc 5.2.1    
 * -#  \b -Os
 * -#  \b -flto
 * \par   :
 * - \ref COLOR
 * - \ref PIX
 * - \ref CONTROL
 * - \ref FFT
 * - \ref EFFECTS
 * - \ref PWR
 * - \ref WS
 */

#include <avr/io.h>
#include "avr_helper.h"
#include <util/crc16.h>
#include <stdlib.h>
#include <avr/interrupt.h>
#include "ws2812.h"
#include "pixel.h"
#include "global.h"
#include "sd_script.h"
#include "avr/wdt.h"

/**    
 * <b>KNOW-HOW  ARV</b>  ,   rand()    
 *      :     
 *         
 * ,      .     
 *  ,  ,     
 *        "".
 */
static void  init_rand(void){
	uint8_t *ptr = (void*)RAMSTART;
	uint16_t seed;

	for(uint16_t i=0; i < RAMEND; i++){
		seed = _crc16_update(seed, *ptr++);
	}
	srand(seed);
}

static void fade_out(pixel_t *px){
	if(px->fade < 0){
		if((px->bright - px->fade) > 255){
			px->bright = 255;
			px->fade = -px->fade;
		}else
			px->bright -= px->fade;
	} else {
		if(px->bright >= px->fade)
			px->bright -= px->fade;
		else
			px->bright = 0;
	}
}

/**
 *           
 * #pixel_t.fade - . #fade.
 */
static void fade(void){
	static uint8_t div = FADE_DIV;
	if(--div) return;
	div = FADE_DIV;
	pixel_t *pixel = pixels;
	for(uint8_t i=0; i<PIXEL_CNT; i++){
		fade_out(pixel++);
	}
}


static volatile uint8_t done_wait;

//  100   
ISR(TIMER1_COMPA_vect){
	static uint8_t sec = 100;
	done_wait = 1;
	if(!--sec){
		sec = 100;
		if(play_limit) play_limit--;
	}
}

/// 

INIT(6){
	init_rand();
}

INIT(7){
	DDR(PORT_SPI) = WS_LOCK_PIN | _BV(PIN_MOSI) | _BV(PIN_SS) | _BV(PIN_SCK);
	DDR(DEBUG_LED_PORT) = _BV(DEBUG_LED_PIN);
	TCCR1B = _BV(WGM12) | TIMER_CLK_DIV_256;
	OCR1A = 625;
	TIMSK = _BV(OCIE1A);
}

/** 
 *        .    ,
 *       10 ,    , 
 *    10 .  ,      
 *      100    ( 
 *  ).
 *      CPU   
 *   , ..   ,  ,  
 *    ,     -  ,  ,
 *   10    .
 */
static void synchronize(void){
	//        10 
	while(!done_wait){
	}
	done_wait = 0;
}

MAIN(){
	//debug_cmd("RST");
	//wdt_enable(WDTO_2S);
	sei();
	while(1){
		//   
		ws2812_show();
		// 
		fade();
		//   
		play_script();
		wdt_reset();
		synchronize();
	}
}

