/** \file pixel.h
 * \brief     
 *        
 * RGB-
 * \author ARV
 * \date	6 . 2017 .
 * \copyright Copyright 2015  ARV. All rights reserved.
 *
 * \defgroup PIX   RGB-
 * \brief    
 *
 *  -      WS2812,  
 * .   ,   ,    
 *  .    (. \ref EFFECTS) ,
 *       .
 *        ,  
 *    .
 * \addtogroup PIX
 * @{
 */

#ifndef PIXEL_H_
#define PIXEL_H_
#include "color_transform.h"

///   
#define PIXEL_CNT		32
#define PIXEL_LEN		1
#define REPEAT_LINE		1

extern uint8_t pixel_cnt;
extern uint8_t rep_lin;

///     ,     
#define PIXEL_CNT_MASK	0x1F

/// ,   
typedef struct pixel_t{
	union{
		rgb_t 			rgb;
		struct{
			uint8_t		g;			///<   
			uint8_t		r;			///<   
			uint8_t		b;			///<   
		};
	};
	uint8_t		bright;		///<  
	int8_t		fade;		///<     
} pixel_t;

///      ( ,  )
// TODO  fade  
#define FADE_DIV	1
///  
extern pixel_t pixels[];


///  
void rnd_pix(uint8_t fix_cid, int8_t fade);
///   
uint8_t get_light_cnt(void);
///  
void bright_ctrl(uint8_t id, uint8_t bright, int8_t fade);
///     
void set_fix_color(uint8_t pos, uint8_t fix_cid);
///   
void set_rgb_color(uint8_t pos, uint8_t r, uint8_t g, uint8_t b);
void set_hsv_color(uint8_t pos, hsv_t hsv);
///   
void off_all_pixels(void);
void rnd_pix_rgb(uint8_t _r, uint8_t _g, uint8_t _b, int8_t fade);
uint8_t is_light_pix(uint8_t id);
/**
 * @}
 */
#endif /* PIXEL_H_ */
